"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable @typescript-eslint/no-unsafe-call */
const dynamic_1 = __importDefault(require("next/dynamic"));
const lazy_hydrate_1 = __importDefault(require("./lazy-hydrate"));
const defaultVisibleOption = () => ({
    rootMargin: '50px',
});
let moduleId = 0; // Static counter
function lazyLoadHydrate(module, option = {
    on: [['visible', defaultVisibleOption]],
}) {
    moduleId++;
    return (0, lazy_hydrate_1.default)({
        on: option.on,
        onBefore: module,
        wrapperProps: Object.assign(Object.assign({}, option.wrapperProps), { 'data-hydration-id': `c-${moduleId}` }),
    })((0, dynamic_1.default)(module, {
        loading: () => {
            var _a;
            const componentHTML = (_a = window.document.querySelector(`[data-hydration-id=c-${moduleId}]`)) === null || _a === void 0 ? void 0 : _a.innerHTML;
            if (!componentHTML) {
                return null;
            }
            return ((0, jsx_runtime_1.jsx)("div", { suppressHydrationWarning: true, dangerouslySetInnerHTML: { __html: componentHTML } }));
        },
        ssr: true,
    }));
}
exports.default = lazyLoadHydrate;
